/**
  Distrust - Cleans up browser trails and leftovers
  Copyright (C) 2006 Itamar Kerbel
  http://www.gness.org/
  trustme@gness.com

  This library is free software; you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation; either version 2.1 of the License, or (at
  your option) any later version.

  This library is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESSFOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
  for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with this library; if not, write to the Free Software Foundation,
  Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
**/

var gdistrustBundle = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
var mystrings = gdistrustBundle.createBundle("chrome://dt/locale/distrustOnOff.properties");
var strDTIsOn = mystrings.GetStringFromName("dtIsEnabled");
var strDTIsOff = mystrings.GetStringFromName("dtIsDisabled");
const STATE_START 			= Components.interfaces.nsIWebProgressListener.STATE_START; 
const NOTIFY_STATE_DOCUMENT = Components.interfaces.nsIWebProgress.NOTIFY_STATE_DOCUMENT; 
const STATE_IS_DOCUMENT 	= Components.interfaces.nsIWebProgressListener.STATE_IS_DOCUMENT; 

var dt_prefs = new DT_Prefs();

 // add pref observers
this.PrefChangeObserver = {
	observe: function(aSubject, aTopic, aData)
	{
		prefChanged(aData);
	}
};
/***************************************************/
function prefChanged(prefName) {
	switch(prefName){
		case DT_STATUS_IMAGE_PREF:
			updateStatusBarIndicatior();
			break;
	}
}
/***************************************************/
function updateStatusImage(privacyState) {
	logMsg("updateStatusImage");
	var statusPanelImage = document.getElementById("dt-status-image");
	if (privacyState == true) {
		statusPanelImage.src = "chrome://dt/content/eye.png";
		statusPanelImage.tooltipText= strDTIsOn;
	}
	else {
		statusPanelImage.src = "chrome://dt/content/eye_gray.png";
		statusPanelImage.tooltipText= strDTIsOff;
		closeMarkedTabs();
	}
}
/***************************************************/
function panelPressed(event) {
	//toggleDistrustState();
	var DTComponent = Components.classes['@gness.com/firefox/distrust;1'].getService(Components.interfaces.dtIDistrustService);
	if (DTComponent != null)
		DTComponent.toggleState();
}
/***************************************************/
function init() {
	logMsg("ui init");
	listenToEvent(window, "load", GM_hitch(this, "chromeLoad"));
	listenToEvent(window, "unload", GM_hitch(this, "chromeUnload"));
	listenToEvent(window.getBrowser(), "TabOpen", GM_hitch(this, "tabOpened"));		
    //listenToEvent(document.getElementById("appcontent"), "DOMContentLoaded", GM_hitch(this, "contentLoad"));


	//listenToEvent(window.getBrowser(), "TabClose", GM_hitch(this, "tabClosed"));	
}
/***************************************************/
function contentLoad(evt) {
logMsg("*****************contentLoad*************");	
}
/***************************************************/
function tabOpened(evt) {
	if (dt_prefs.getDTPref(DT_CLOSE_WIN_PREF,true) != true)
		return;
		
	var DTComponent = Components.classes['@gness.com/firefox/distrust;1'].getService(Components.interfaces.dtIDistrustService);
	if (DTComponent.getIsActive()) {
		tab = evt.originalTarget;
		tab.dtAttr = "closeMe";
		logMsg("*****************SET TAB TO BE CLOSED*************");
	}
}
/***************************************************/
function tabClosed(evt) {
	logMsg("*****************CLOSE TAB*************");
	
}
/***************************************************/
function closeMarkedTabs() {	
	logMsg("*****************CLOSING TABS*************");
	if (dt_prefs.getDTPref(DT_CLOSE_WIN_PREF,true) != true)
		return;
	if ((window.dtAttr != undefined) && (window.dtAttr == "closeMe")) {
		var DTComponent = Components.classes['@gness.com/firefox/distrust;1'].getService(Components.interfaces.dtIDistrustService);
	
		if (DTComponent.getNumOfWindows() == 1) {
			closeAllTabs();
			window.location = "about:blank";
			window.dtAttr = "dontCloseMe";
		}
		else {
			window.close();
		}
		return;
	}
	var tblength = window.getBrowser().mTabContainer.childNodes.length;
	for(var loop = tblength-1; loop >=0; loop--)
		{
		try {
			tab = window.getBrowser().mTabContainer.childNodes[loop];
			if ((tab.dtAttr != undefined) && (tab.dtAttr == "closeMe")) {
				
				if (window.getBrowser().mTabContainer.childNodes.length == 1)
					window.close();
				else
					window.getBrowser().removeTab(tab);
			}
			else if ((tab.dtAttr != undefined) && (tab.dtAttr == "URL")) {
				logMsg("Setting back tab to URL: " + tab.dtURL);	
				var tabBrowser = window.getBrowser().getBrowserForTab(tab);
				tabBrowser.loadURI(tab.dtURL,null,null);
				//tab.location = tab.dtURL;
			}
			
		}
		catch(e) {
			logMsg("Failed to close tabs");
		}
	}
}
/***************************************************/
function closeAllTabs() {
	var tblength = window.getBrowser().mTabContainer.childNodes.length;
	for(var loop = tblength-1; loop >=0; loop--)
	{
		try {
			tab = window.getBrowser().mTabContainer.childNodes[loop];
			window.getBrowser().removeTab(tab);
		}
		catch(e) {
			logMsg("Failed to close all tabs");
		}

	}
}
/***************************************************/
/**
 * The browser's location has changed. Usually, we don't care. 
 */


function onStateChange(aProgress,aRequest,aFlag,aStatus){
	if(aFlag & (STATE_IS_DOCUMENT|STATE_START)) { 
		var DTComponent = Components.classes['@gness.com/firefox/distrust;1'].getService(Components.interfaces.dtIDistrustService);
		if (DTComponent.getIsActive()) {
			realTab = aProgress.DOMWindow;
			var tabIndex = window.getBrowser().getBrowserIndexForDocument(realTab.document);
			logMsg("Tab number " + tabIndex + " was changed");

			tab = window.getBrowser().mTabContainer.childNodes[tabIndex];
			
			if ((tab.dtAttr != undefined) && (tab.dtAttr == "closeMe")) {
				return;
			} 
			else if (tab.dtAttr == undefined) {
				logMsg("Location Changeing. set last good location to - " + aProgress.DOMWindow.location);
				tab.dtAttr = "URL";
				tab.dtURL = aProgress.DOMWindow.location + "";//we want the string not the object
			}
		}
	}
}
// necessary for webProgressListener implementation
function onLocationChange(a,b,c) {}
function onProgressChange(webProgress,b,c,d,e,f){}
function onStatusChange(a,b,c,d){}
function onSecurityChange(a,b,c){}
function onLinkIconAvailable(a){}



/***************************************************/
function chromeLoad(evt) {
	logMsg("chrome loaded");
	
	var DTComponent = Components.classes['@gness.com/firefox/distrust;1'].getService(Components.interfaces.dtIDistrustService);
	if (DTComponent != null) {
		DTComponent.registerWindow(this);
		var dtActive = DTComponent.getIsActive();
		updateStatusImage(dtActive);
		if (dtActive) {
			window.dtAttr = "closeMe";
		}
	}
	
	updateStatusBarIndicatior();
	dt_prefs.addObserver("distrust.ui", this.PrefChangeObserver);
	//document.getElementById("content").addProgressListener(this,Components.interfaces.nsIWebProgress.NOTIFY_LOCATION);
	document.getElementById("content").addProgressListener(this,NOTIFY_STATE_DOCUMENT);
}
/***************************************************/
function updateStatusBarIndicatior() {
	var panel = document.getElementById("dt-status-panel");
	if (dt_prefs.getDTPref(DT_STATUS_IMAGE_PREF,true) == false)
		panel.hidden = true;
	else
		panel.hidden = false;
}
/***************************************************/
function getPlatform() {
	return window.navigator.platform;
}
/***************************************************/
function chromeUnload(evt) {
	logMsg("chrome un-loaded");
	
	var DTComponent = Components.classes['@gness.com/firefox/distrust;1'].getService(Components.interfaces.dtIDistrustService);
	if (DTComponent != null)
		DTComponent.unregisterWindow(this);
		
	dt_prefs.removeObserver("distrust.ui", this.PrefChangeObserver);
	unlistenToEvent(window, "load", GM_hitch(this, "chromeLoad"));
	unlistenToEvent(window, "unload", GM_hitch(this, "chromeUnload"));
	unlistenToEvent(window.getBrowser(), "TabOpen", GM_hitch(this, "tabOpened"));	
	//unlistenToEvent(window.getBrowser(), "TabClose", GM_hitch(this, "tabClosed"));	
	document.getElementById("content").removeProgressListener(this);
}

/***************************************************/
init();

/***************************************************/
/***************************************************/
/***************************************************/
//old code left for future reference
/*
function makeURL(aURL) 
 { 
 var ioService = Components.classes["@mozilla.org/network/io-service;1"] 
 .getService(Components.interfaces.nsIIOService); 
 return ioService.newURI(aURL, null, null); 
 } 
 */
/***************************************************/
/*
function deleteEntryFromHistory(href) { 
 
 var globalHistory = Components.classes["@mozilla.org/browser/global-history;2"] 
 .getService(Components.interfaces.nsIBrowserHistory); 
 
 var uri = makeURL(href); 
 globalHistory.removePage(uri); 
 }
 */


//this code is based upon mozilla RDF example
//http://www.mozilla.org/rdf/doc/rdf-all-resources-example.html
// the magic function
// we will travese through the arcs
// and if they have RDFNodes at the end, print out the value
// but if they are resources, call this function again until we hit the
// the end
/*
function showArcs(myDatasource,thisResource, arcCursor) {

     while(arcCursor.hasMoreElements()) {

         logMsg("arcCursor has elements:");
         var thisArc = arcCursor.getNext().QueryInterface(
                   Components.interfaces.nsIRDFResource);


         logMsg("thisArc --> " + thisArc.Value + " <--");


         // you should look in the IDL for nsIRDFDataSource
         // Honestly, I had tried this with GetSources, but that does not
         // work, and I don't know why.  
         var arcTargets = myDatasource.GetTargets(
                         thisResource,
                         thisArc,
                         true );


         while(arcTargets.hasMoreElements()) {


             logMsg("arcTargets has elements");
             var thisTarget = arcTargets.getNext();
			//logMsg("thisTarget111 --> " + thisTarget + " <--");
			if (thisTarget == null)
				continue;			

             // we are looking to catch the NO_INTERFACE exceptoin
             // if we cannot attach the nsIRDFLiteral interface
             // we know we have an nsIRDFResource, and should look at
             // that resource's arcs.

             try {
				if (thisTarget instanceof Components.interfaces.nsIRDFLiteral){
					thisTarget.QueryInterface(
                     Components.interfaces.nsIRDFLiteral);

                 		logMsg("thisTarget --> " + thisTarget.Value + " <--");
				}
				else if (thisTarget instanceof Components.interfaces.nsIRDFResource) {
//					logMsg("***FOUND RESOURCE !!! --> " + thisTarget + " <--");
					logMsg("***FOUND RESOURCE !!! --> " + thisTarget.Value + " <--");
				}
				else if (thisTarget instanceof Components.interfaces.nsIRDFDate) {
//					logMsg("***FOUND DATE !!! --> " + thisTarget + " <--");
					logMsg("***FOUND DATE !!! --> " + thisTarget.Value + " <--");
					logMsg("***FOUND DATE !!! --> " + new Date(thisTarget.Value/1000).toGMTString() + " <--");
					if (initTime.getTime() < thisTarget.Value/1000)
						logMsg("~~~~~~DATE IS IN SESSION"); 
					
				}
				else {
					continue;
					var newArcCursor = myDatasource.ArcLabelsOut(thisTarget);
                	// recurse down these new arcs
                	showArcs(myDatasource,thisTarget, newArcCursor);
					
				}

             } catch(e) {
				
                var newArcCursor = myDatasource.ArcLabelsOut(
                               thisTarget);
                // recurse down these new arcs
                //showArcs(myDatasource,thisTarget, newArcCursor);
             }

         }
     }
*/	 

/* //old code left for future reference
 var datasource = this.tree.database;
  var dsEnum = datasource.GetDataSources();
  dsEnum.getNext();
  var ds = dsEnum.getNext()
                 .QueryInterface(Components.interfaces.nsIRDFDataSource);

  var count = this.treeSelection.count;
 
  // XXX 9 is a random number, just looking for a sweetspot
  // don't want to rebuild tree content for just a few items
  if (count > 9) {
    ds.beginUpdateBatch();
  }

  var min = new Object();
  var max = new Object();
  var dirty = false;
  for (var i = rangeCount - 1; i >= 0; --i) {
    this.treeSelection.getRangeAt(i, min, max);
    for (var k = max.value; k >= min.value; --k) {
      if (!gRDF)
        gRDF = Components.classes[rdf_contractid].getService(Components.interfaces.nsIRDFService);

      var IDRes = this.treeBuilder.getResourceAtIndex(k);
      if (!IDRes)
        continue;

      var root = this.tree.getAttribute('ref');
      var parentIDRes;
      try {
        parentIDRes = this.treeBuilder.getResourceAtIndex(this.treeView.getParentIndex(k));
      }
      catch(ex) {
        parentIDRes = gRDF.GetResource(root);
      }
      if (!parentIDRes)
        continue;
     
      // otherwise remove the parent/child assertion then
      var containment = gRDF.GetResource("http://home.netscape.com/NC-rdf#child");
      ds.Unassert(parentIDRes, containment, IDRes);
      dirty = true;
    }
  }

  if (count > 9) {
    ds.endUpdateBatch();
  }

  if (dirty) {   
    try {
      var remote = datasource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
      remote.Flush();
    } catch (ex) {
    }
  }****************************/


