/**
  Distrust - Cleans up browser trails and leftovers
  Copyright (C) 2006 Itamar Kerbel
  http://www.gness.org/
  trustme@gness.com

  This library is free software; you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation; either version 2.1 of the License, or (at
  your option) any later version.

  This library is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESSFOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
  for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with this library; if not, write to the Free Software Foundation,
  Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
**/


const DT_AUTOSTART_PREF = "distrust.core.autostart";
const DT_HISTORY_PREF = "distrust.core.history";
const DT_DOWNLOADS_PREF = "distrust.core.downloads";
const DT_DOWNLOADS_DISK_PREF = "distrust.core.downloads_disk";
const DT_DISK_CACHE_PREF = "distrust.core.disk_cache";
const DT_FORM_INFO_PREF = "distrust.core.form_info";
const DT_COOKIES_PREF = "distrust.core.cookies";
const DT_TABS_PREF = "distrust.core.tabs";
const DT_STATUS_IMAGE_PREF = "distrust.ui.statusImage";
const DT_LSO_PREF = "distrust.core.slo";
const DT_CLOSE_WIN_PREF = "distrust.core.close_windows";
const DT_LSO_DIR = "distrust.core.flashAppDir";
const  PREF_INVALID = 0; 
const  PREF_STRING = 32;
const  PREF_INT = 64;
const  PREF_BOOL = 128;

function DT_Prefs() {
	DT_Prefs.prototype.setDTPref = function(pref,type,val) {	
		var prefMngr = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranch);
		switch(type) {
			case PREF_BOOL:			
				return	prefMngr.setBoolPref(pref,val);
			case PREF_INT:
				return	prefMngr.setIntPref(pref,val);
			case PREF_STRING:
				return	prefMngr.setCharPref(pref,val);
		}
		return null;
	}
	
	DT_Prefs.prototype.getDTPref = function(pref,default_val) {
		var prefMngr = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranch);
		try {
			switch(prefMngr.getPrefType(pref)) {
				case PREF_BOOL:
					return	prefMngr.getBoolPref(pref);
				case PREF_INT:
					return	prefMngr.getIntPref(pref);
				case PREF_STRING:
					return	prefMngr.getCharPref(pref);
			}
		} catch (e) {}
		return default_val;
	}	
	
	DT_Prefs.prototype.addObserver = function(aDomain, aFunction) {
	  var prefMngr = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranch);
	  var prefBranchInternal = prefMngr.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
	
	  if (prefBranchInternal)
		prefBranchInternal.addObserver(aDomain, aFunction, false);
	}
	
	DT_Prefs.prototype.removeObserver = function(aDomain, aFunction) {
	  var prefMngr = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranch);
	  var prefBranchInternal = prefMngr.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
	
	  if (prefBranchInternal)
		prefBranchInternal.removeObserver(aDomain, aFunction);
	}
}